LoggingEvent Class Reference

The internal representation of logging events. More...

Inherits ObjectImpl.

## Public Member Functions

| LoggingEvent ()
| For serialization only. More...
| LoggingEvent (const LogString &logger, const LevelPtr &level, const LogString &message, const log4cxx::spi::LocationInfo &location)
| Instantiate a LoggingEvent from the supplied parameters. More...
| ~LoggingEvent ()
const LevelPtr & | getLevel () const
| Return the level of this event. More...
const LogString & | getLoggerName () const
| Return the name of the logger. More...
const LogString & | getMessage () const
| Return the message for this logging event. More...
const LogString & | getRenderedMessage () const
| Return the message for this logging event. More...
const LogString & | getThreadName () const
| Return the threadName of this event. More...
log4cxx_time_t | getTimeStamp () const
| Return the timeStamp of this event. More...
const log4cxx::spi::LocationInfo & | getLocationInformation () const
bool | getNDC (LogString &dest) const
| This method appends the NDC for this event to passed string. More...
void | write (helpers::ObjectOutputStream &os, helpers::Pool &p) const
| Writes the content of the LoggingEvent in a format compatible with log4j's serialized form. More...
bool | getMDC (const LogString &key, LogString &dest) const
| Appends the the context corresponding to the `key` parameter. More...
| LOG4CXX_LIST_DEF (KeySet, LogString)
KeySet | getMDCKeySet () const
| Returns the set of of the key values in the MDC for the event. More...
void | getMDCCopy () const
| Obtain a copy of this thread's MDC prior to serialization or asynchronous logging. More...
bool | getProperty (const LogString &key, LogString &dest) const
| Return a previously set property. More...
KeySet | getPropertyKeySet () const
| Returns the set of of the key values in the properties for the event. More...
void | setProperty (const LogString &key, const LogString &value)
| Set a string property using a key and a string value. More...
Public Member Functions inherited from ObjectImpl
| ObjectImpl ()
virtual | ~ObjectImpl ()
void | addRef () const
void | releaseRef () const
Public Member Functions inherited from Object
virtual const helpers::Class & | getClass () const
virtual | ~Object ()
virtual bool | instanceof (const Class &clazz) const =0
virtual const void * | cast (const Class &clazz) const =0

## Static Public Member Functions

static log4cxx_time_t | getStartTime ()
| Returns the time when the application started, in seconds elapsed since 01.01.1970. More...

## Additional Inherited Members

Protected Attributes inherited from ObjectImpl
unsigned int volatile | ref

## Detailed Description

The internal representation of logging events.

When an affirmative decision is made to log then a `LoggingEvent` instance is created. This instance is passed around to the different log4cxx components.

This class is of concern to those wishing to extend log4cxx.

## Constructor & Destructor Documentation

LoggingEvent | ( |  | ) |

For serialization only.

LoggingEvent | ( | const LogString & | logger,
|  | const LevelPtr & | level,
|  | const LogString & | message,
|  | const log4cxx::spi::LocationInfo & | location
| ) |  |

Instantiate a LoggingEvent from the supplied parameters.

Except timeStamp all the other fields of `LoggingEvent` are filled when actually needed.

Parameters

  logger | The logger of this event.
  level | The level of this event.
  message | The message of this event.
  location | location of logging request.

~LoggingEvent | ( |  | ) |

## Member Function Documentation

const LevelPtr& getLevel | ( |  | ) | const

inline

Return the level of this event.

const log4cxx::spi::LocationInfo& getLocationInformation | ( |  | ) | const

inline

const LogString& getLoggerName | ( |  | ) | const

inline

Return the name of the logger.

bool getMDC | ( | const LogString & | key,
|  | LogString & | dest
| ) |  | const

Appends the the context corresponding to the `key` parameter.

If there is a local MDC copy, possibly because we are in a logging server or running inside AsyncAppender, then we search for the key in MDC copy, if a value is found it is returned. Otherwise, if the search in MDC copy returns an empty result, then the current thread's `MDC` is used.

Note that both the local MDC copy and the current thread's MDC are searched.

Parameters

  key | key.
  dest | string to which value, if any, is appended.

Returns
  true if key had a corresponding value.

void getMDCCopy | ( |  | ) | const

Obtain a copy of this thread's MDC prior to serialization or asynchronous logging.

KeySet getMDCKeySet | ( |  | ) | const

Returns the set of of the key values in the MDC for the event.

The returned set is unmodifiable by the caller.

Returns
  Set an unmodifiable set of the MDC keys.

const LogString& getMessage | ( |  | ) | const

inline

Return the message for this logging event.

bool getNDC | ( | LogString & | dest | ) | const

This method appends the NDC for this event to passed string.

It will return the correct content even if the event was generated in a different thread or even on a different machine. The NDC::get method should never be called directly.

Parameters

  dest | destination for NDC, unchanged if NDC is not set.

Returns
  true if NDC is set.

bool getProperty | ( | const LogString & | key,
|  | LogString & | dest
| ) |  | const

Return a previously set property.

Parameters

  key | key.
  dest | string to which value, if any, is appended.

Returns
  true if key had a corresponding value.

KeySet getPropertyKeySet | ( |  | ) | const

Returns the set of of the key values in the properties for the event.

The returned set is unmodifiable by the caller.

Returns
  Set an unmodifiable set of the property keys.

const LogString& getRenderedMessage | ( |  | ) | const

inline

Return the message for this logging event.

static log4cxx_time_t getStartTime | ( |  | ) |

static

Returns the time when the application started, in seconds elapsed since 01.01.1970.

const LogString& getThreadName | ( |  | ) | const

inline

Return the threadName of this event.

log4cxx_time_t getTimeStamp | ( |  | ) | const

inline

Return the timeStamp of this event.

LOG4CXX_LIST_DEF | ( | KeySet | ,
|  | LogString |
| ) |  |

void setProperty | ( | const LogString & | key,
|  | const LogString & | value
| ) |  |

Set a string property using a key and a string value.

since 1.3

void write | ( | helpers::ObjectOutputStream & | os,
|  | helpers::Pool & | p
| ) |  | const

Writes the content of the LoggingEvent in a format compatible with log4j's serialized form.

The documentation for this class was generated from the following file:

- loggingevent.h